/* Sistemas Integrados TEKNISA
  Documentos Fiscais de Entrada

Nome: 5299_DFETRGO.SQL

@C:\web_600\sql\end_conv\sqlserver\5299_DFETRGS_USR_BLOQUEIA_DUPLICACAO.SQL

Descrio:
Rotina para bloqueio de duplicidade de lanamento de nota fiscal.

Criao:
10/10/2010 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE
            O.NAME = 'USR_BLOQUEIA_DUPLICACAO'    AND
            TYPE = 'TR'                           AND
            U.UID = O.UID                         AND
            U.NAME = USER)
DROP TRIGGER USR_BLOQUEIA_DUPLICACAO
GO

CREATE TRIGGER USR_BLOQUEIA_DUPLICACAO
ON NOTAFISCAL
FOR INSERT
AS

DECLARE @NEW_IDENTRSAIDOP   VARCHAR(01);
DECLARE @NEW_CDFILIRECE     VARCHAR(04);
DECLARE @NEW_NRNOTAFISC     VARCHAR(20);
DECLARE @NEW_CDSERIEENTR    VARCHAR(05);
DECLARE @NEW_NRINSJURNF     VARCHAR(20);
DECLARE @NEW_VRNOTAFISC     NUMERIC(15,6);
DECLARE @NEW_NRLANCTONF     VARCHAR(10);
DECLARE @NEW_CDFILIAL       VARCHAR(04);
DECLARE @NEW_IDSTATUSNFE    VARCHAR(01);
DECLARE @NEW_IDSTATUS       VARCHAR(01);
DECLARE @NEW_CDTIPOOPER     VARCHAR(02);


DECLARE @V_NUMANT           DOUBLE PRECISION;

DECLARE @V_MENSAGEM         VARCHAR(60);
DECLARE @V_IDINFCPFCNPJNF   VARCHAR(1);

BEGIN

   SELECT
      @NEW_IDENTRSAIDOP = IDENTRSAIDOP,
      @NEW_CDFILIRECE   = CDFILIRECE,
      @NEW_NRNOTAFISC   = NRNOTAFISC,
      @NEW_CDSERIEENTR  = CDSERIEENTR,
      @NEW_NRINSJURNF   = NRINSJURNF,
      @NEW_VRNOTAFISC   = VRNOTAFISC,
      @NEW_NRLANCTONF   = NRLANCTONF,
      @NEW_CDFILIAL     = CDFILIAL,
      @NEW_NRLANCTONF   = NRLANCTONF,
      @NEW_IDSTATUSNFE  = IDSTATUSNFE,
      @NEW_IDSTATUS     = IDSTATUS
   FROM INSERTED;

   IF ((@NEW_IDENTRSAIDOP = 'E') AND NOT(@NEW_IDSTATUS = 'C') AND NOT(@NEW_IDSTATUSNFE = 'C') AND (NOT @NEW_NRNOTAFISC IS NULL)) BEGIN

      SELECT @V_NUMANT = ISNULL(CAST(MAX(ISNULL(NRLANCTONF,'0')) AS DOUBLE PRECISION),0)
        FROM NOTAFISCAL
       WHERE CDFILIRECE   = @NEW_CDFILIRECE
         AND NRNOTAFISC   = @NEW_NRNOTAFISC
         AND CDSERIEENTR  = @NEW_CDSERIEENTR
         AND IDENTRSAIDOP = @NEW_IDENTRSAIDOP
         AND NRINSJURNF   = @NEW_NRINSJURNF
         AND VRNOTAFISC   = @NEW_VRNOTAFISC
         AND CDFILIAL+NRLANCTONF <> @NEW_CDFILIAL+@NEW_NRLANCTONF;

      IF (CAST(@NEW_NRLANCTONF AS DOUBLE PRECISION) - @V_NUMANT) < 4 BEGIN
         SELECT @V_IDINFCPFCNPJNF = IDINFCPFCNPJNF
           FROM TIPOOPERAC
          WHERE CDTIPOOPER     = @NEW_CDTIPOOPER
            AND IDENTRSAIDOP   = @NEW_IDENTRSAIDOP;

         IF @V_IDINFCPFCNPJNF <> 'S' BEGIN
            SET @V_MENSAGEM = ('Documento j lanado no sistema.');
            RAISERROR(@V_MENSAGEM, 16,1);
         END;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'USR_BLOQUEIA_DUPLICACAO','6.00.XXX';
GO

